#!/usr/bin/python

import os
import xml.sax
from xml.sax.saxutils import quoteattr,escape
import sys
import codecs
import argparse
import re
import pprint

import xml.sax.saxutils

# Script for deleting records from EG authorities database that have no "040" datafield.


# SAX parser of EG authorities file
class egExportParser(xml.sax.handler.ContentHandler):
	def startDocument(self):
		self.controlfield=None
		self.datafield=None
		self.subfield=None
		self.record=None
		self.recordData=None
		self.isRecord=False
		self.counter=0
		self.txtXml=""
		self.idIn=None
		self.writeToOutput=False
		self.writeToCut=False
		self.ind1=None
		self.ind2=None
		self.missing_field_40=True

		self.counter_missing_40=0

	def startElement(self,tag,attrs):
		if tag=="datafield":
			self.datafield=attrs.get('tag')
			self.ind1=attrs.get('ind1')
			self.ind2=attrs.get('ind2')

			self.subfield=None
			self.controlfield=None

			self.subfield=None
			if self.datafield!=None and self.ind1!=None and self.ind2!=None:
				self.txtXml+='<datafield tag=\"'+self.datafield+'\"'
				self.txtXml+=' ind1=\"'+self.ind1+'\" ind2=\"'+self.ind2+'\">'
			if self.datafield!=None and self.ind1!=None and self.ind2==None:
				self.txtXml+='<datafield tag=\"'+self.datafield+'\"'
				self.txtXml+=' ind1=\"'+self.ind1+'\">'
			if self.datafield!=None and self.ind1==None and self.ind2!=None:
				self.txtXml+='<datafield tag=\"'+self.datafield+'\"'
				self.txtXml+=' ind2=\"'+self.ind2+'\">\n'
			elif self.datafield==None:
				self.txtXml+='<datafield>'

		elif tag=="subfield":
			self.datafield=None
			self.controlfield=None

			self.subfield=attrs.get('code')
			if self.subfield!=None:
				self.txtXml+='<subfield code=\"'+self.subfield+'\">'
			elif self.subfield==None:
				self.txtXml+='<subfield>'

		elif tag=="controlfield":
			self.datafield=None
			self.subfield=None

			self.controlfield=attrs.get('tag')
			if self.controlfield!=None:
				self.txtXml+='<controlfield tag=\"'+self.controlfield+'\">'
			elif self.controlfield==None:
				self.txtXml+='<controlfield>'

		elif tag=="record":
			self.datafield=None
			self.subfield=None
			self.controlfield=None

			self.missing_field_40=True
			self.counter+=1
			if not self.counter%1000:
				print ".",
				sys.stdout.flush()
			self.txtXml+='<record>\n'

		elif tag=="leader":
			self.txtXml+='<leader>'


	def characters(self,data):
		if self.datafield=="040":
			self.missing_field_40=False
		dataEscaped = xml.sax.saxutils.escape(data)
		self.txtXml += dataEscaped.rstrip()

	def endElement(self,tag):
		if tag=="datafield":
			self.txtXml+='</datafield>\n'
			self.ind1=None
			self.ind2=None
		elif tag=="subfield":
			self.txtXml+='</subfield>\n'
		elif tag=="controlfield":
			self.txtXml+='</controlfield>\n'
		elif tag=="leader":
			self.txtXml+='</leader>\n'
		elif tag=="record": 
			self.txtXml+='</record>\n'

			if self.missing_field_40:
				#self.counter_missing_40+=1
				#print self.counter_missing_40
				pass
			else:
				outXmlFile.write(self.txtXml)
			self.txtXml=""


print "Pocet zaznamu bez pole 40: "
# parser that interacts with the user
parser = argparse.ArgumentParser(description='Hello there')

# paths to the individual files to parse
parser.add_argument("egFile",nargs='?',help="export XML file",default="aut_exp.xml") 
parser.add_argument("-o","--output",help="output file",default="cut0.xml")

args = parser.parse_args()

egFile=args.egFile
pathOut = args.output

# writing the correct XML header to the begining of the created XML files
outXmlFile = codecs.open(pathOut,"w","utf-8")
outXmlFile.write("""<?xml version = "1.0" encoding = "UTF-8"?>\n""")
outXmlFile.write("""<collection xmlns='http://www.loc.gov/MARC21/slim'>\n""")

egExportParser = egExportParser()
parser = xml.sax.parse(egFile, egExportParser)

# print out the number of records we went through

outXmlFile.write("</collection>")
outXmlFile.close()

print "Konec :]"